/* MCPU Projekt fuers Cyclone II Chinaboard
   Hauptmodul, fuer erste einfache Tests von Teilfunktionen:
   
   Umschalter EDIT/CPU sowie Display
*/

`include "utils/busmux.v"     // Bus-Multiplexer
`include "utils/debouncer.v"  // Entprellung fuer Taster und Umschalter
`include "moduls/DISPctrl.v"  // Steuerung 7-Seg-Anzeige

module main (
 input  wire clk,	// Systemtakt
 input  wire Switch1,	// Umschalter EDIT/CPU
 output wire [7:0] seg,
 output wire [7:0] digit 
);

wire [5:0] Addr;
wire [7:0] Data;
wire Modus; 

 Debouncer SW1 (.clk(clk), .PB(Switch1), .PB_state(Modus) );
 DISPctrl Anzeige  (.clk(clk),
                    .Addr(Addr),
						  .Data(Data),
						  .mode(Modus),
						  .CPUstate(stat),
						  .Carry(Carry),
						  .Instr(code),
						  .seg(seg),
						  .digit(digit));

 BusMux #(14) Mux1 (.sel(Modus), 
                    .InpA({Addr1,Data1}),
						  .InpB({Addr2,Data2}),
						  .Out({Addr,Data}) );

 // vorlaeufige Testdaten fuers Display:
 wire [5:0] Addr1 = 6'h13;
 wire [7:0] Data1 = 8'h35;
 wire [5:0] Addr2 = 6'h19;
 wire [7:0] Data2 = 8'hFF;
 wire Carry = 1;
 wire [1:0] stat = 2'h2;	// Prozessor-Status
 wire [7:0] code = 8'h4B;	// akt. Maschinencode
 
endmodule
